<template>
  <div class="posts">
    <h1>Add Post</h1>
    <form @submit.prevent="addPost" enctype="multipart/form-data" class="form">
      <div>
        <input type="text" name="title" placeholder="TITLE" v-model="title">
      </div>
      <div v-if="title_error != ''">
        <p class="form-error">{{ title_error }}</p>
      </div>
      <div>
        <textarea rows="15" cols="15" placeholder="DESCRIPTION" v-model="description"></textarea>
      </div>
      <div>
        <input type="text" name="author" placeholder="AUTHOR" v-model="author">
      </div>
      <div v-if="author_error != ''">
        <p class="form-error">{{ author_error }}</p>
      </div>
      <div>
        <input type="file" :name="uploadFileName" @change="handleFileUpload($event.target.files, $event.target.name)" accept=".png, .jpg, .jpeg">
      </div>
      <div>
        <button :disabled='isDisabled' class="app_post_btn">Submit</button>
      </div>
      <div>
        <router-link v-bind:to="{ name : 'Posts' }">Back</router-link>
      </div>
    </form>
  </div>
</template>
<script>
import PostsService from '@/services/PostsService'
export default {
  name: 'NewPost',
  data () {
    return {
      title: '',
      description: '',
      author: '',
      image: '',
      title_error: '',
      author_error: '',
      uploadedFiles: [],
      uploadFileName: 'file',
      uploadFile: '',
      isDisabled: false
    }
  },
  methods: {
    handleFileUpload (fileList, fileName) {
      this.uploadedFiles = fileList
      this.uploadFile = fileName
    },
    async addPost () {
      if (this.title === '' || this.author === '') {
        this.title_error = (this.title === '') ? 'Please enter post title' : ''
        this.author_error = (this.author === '') ? 'Please enter post author' : ''
      } else {
        this.isDisabled = true
        let data = new FormData()
        data.append('title', this.title)
        data.append('description', this.description)
        data.append('author', this.author)
        if (this.uploadFile !== '') data.append('image', this.uploadedFiles[0], this.uploadedFiles[0].name)
        await PostsService.addPost(data)
        this.$router.push({ name: 'Posts' })
      }
    }
  }
}

</script>
<style type="text/css">
.form input,
.form textarea {
  width: 500px;
  padding: 10px;
  border: 1px solid #e0dede;
  outline: none;
  font-size: 12px;
}

.form div {
  margin: 20px;
}

.app_post_btn {
  background: #4d7ef7;
  color: #fff;
  padding: 10px 80px;
  text-transform: uppercase;
  font-size: 12px;
  font-weight: bold;
  width: 520px;
  border: none;
  cursor: pointer;
}

.form-error {
  color: red;
}

</style>
